// MediaOpenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcPlayer.h"
#include "MediaOpenDlg.h"
#include "afxdialogex.h"


// CMediaOpenDlg dialog

IMPLEMENT_DYNAMIC(CMediaOpenDlg, CDialogEx)

CMediaOpenDlg::CMediaOpenDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMediaOpenDlg::IDD, pParent)
	, m_strMedia(_T(""))
{

}

CMediaOpenDlg::~CMediaOpenDlg()
{
}

void CMediaOpenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CMediaOpenDlg, CDialogEx)
	ON_BN_CLICKED(IDC_BROWSE, &CMediaOpenDlg::OnBnClickedBrowse)
	ON_BN_CLICKED(IDOK, &CMediaOpenDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CMediaOpenDlg message handlers


void CMediaOpenDlg::OnBnClickedBrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("avi Files;mp4 Files|*.avi;*.mp4|All Files|*.*||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_MEDIA, dlg.GetPathName());
	}
}


void CMediaOpenDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	GetDlgItemText(IDC_MEDIA, m_strMedia);
	if (m_strMedia.IsEmpty())
	{
		return;
	}

	CDialogEx::OnOK();
}


BOOL CMediaOpenDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	GetDlgItem(IDC_MEDIA)->SetFocus();

	return FALSE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
