
// VcPlayerDlg.h : header file
//

#pragma once
#include "atltypes.h"


// CVcPlayerDlg dialog
class CVcPlayerDlg : public CDialogEx
{
// Construction
public:
	CVcPlayerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_VCPLAYER_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedMediaopen();
	afx_msg void OnBnClickedPlay();
	afx_msg void OnBnClickedPause();
	afx_msg void OnBnClickedStop();
	afx_msg void OnBnClickedClose();
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedSnapshot();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedFast();
	afx_msg void OnBnClickedSlow();
	afx_msg void OnClickedMute();
	afx_msg void OnBnClickedNextframe();
	afx_msg void OnBnClickedFullscreen();
	afx_msg void OnBnClickedRecord();
protected:
	afx_msg LRESULT OnPlayevent(WPARAM wParam, LPARAM lParam);
private:
	BOOL IsPlay() { return m_hPlay != NULL && (DXPlayGetState(m_hPlay) & (DXPLAY_PLAYING | DXPLAY_PAUSED)); }
	void UpdatePlayState(void);
	play_handle_t m_hPlay;
	BOOL m_bPaused;
	BOOL m_bDrag;
	BOOL m_bFile;
	BOOL m_bFullScreen;
	BOOL m_bRecord;
	CString m_strTime;
	float m_fFps;
	CStatic m_Video;
	CRect m_Rect;
};
