unit OSDSetting;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls,strutils,IniFiles,Dialogs;

type
  TOsdSettingDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label4: TLabel;
    TimeOsd: TCheckBox;
    TimeTranspar: TCheckBox;
    TimePlaceX: TEdit;
    TimePlaceY: TEdit;
    Label2: TLabel;
    TimeFontSize: TEdit;
    Label8: TLabel;
    TimeSetColor: TButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    TextOsd1: TCheckBox;
    TextTranspar1: TCheckBox;
    TextPlaceX1: TEdit;
    TextPlaceY1: TEdit;
    GroupBox5: TGroupBox;
    Label11: TLabel;
    Label6: TLabel;
    TxtFontSize1: TEdit;
    OsdText1: TEdit;
    TxtSetColor1: TButton;
    Label7: TLabel;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    PicOsd1: TCheckBox;
    PictPlaceX1: TEdit;
    PictPlaceY1: TEdit;
    Label12: TLabel;
    PicFilePath1: TEdit;
    PicBrowse1: TButton;
    ColorDialog1: TColorDialog;
    dlgOpen1: TOpenDialog;
    GroupBox4: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TextOsd2: TCheckBox;
    TextTranspar2: TCheckBox;
    GroupBox6: TGroupBox;
    TxtSetColor2: TButton;
    GroupBox7: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    PicOsd2: TCheckBox;
    TextPlaceX2: TEdit;
    TextPlaceY2: TEdit;
    TxtFontSize2: TEdit;
    PictPlaceX2: TEdit;
    PictPlaceY2: TEdit;
    PicFilePath2: TEdit;
    OsdText2: TEdit;
    btnPicBrowse2: TButton;
    ScrTransparValue1: TScrollBar;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    ScrTransparValue2: TScrollBar;
    GroupBox8: TGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    checkDrawRect: TCheckBox;
    GroupBox9: TGroupBox;
    Button1: TButton;
    Label27: TLabel;
    Label30: TLabel;
    GroupBox10: TGroupBox;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    checkCrossLine: TCheckBox;
    GroupBox11: TGroupBox;
    Button2: TButton;
    textRectX: TEdit;
    textRectY: TEdit;
    textRectWidth: TEdit;
    textRectHeight: TEdit;
    textRectLineSize: TEdit;
    textCrossY: TEdit;
    textCrossXWidth: TEdit;
    textCrossYWidth: TEdit;
    textCrossLineSize: TEdit;
    textCrossX: TEdit;
    procedure TimeSetColorClick(Sender: TObject);
    procedure TxtSetColor1Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure TimePlaceXChange(Sender: TObject);
    procedure TimePlaceYChange(Sender: TObject);
    procedure TimeFontSizeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TxtFontSize1Change(Sender: TObject);
    procedure TextPlaceX1Change(Sender: TObject);
    procedure textCrossXChange(Sender: TObject);
    procedure TextPlaceY1Change(Sender: TObject);
    procedure PictPlaceX1Change(Sender: TObject);
    procedure PictPlaceY1Change(Sender: TObject);
    procedure PicBrowse1Click(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure PictPlaceX2Change(Sender: TObject);
    procedure PictPlaceY2Change(Sender: TObject);
    procedure TextPlaceX2Change(Sender: TObject);
    procedure TextPlaceY2Change(Sender: TObject);
    procedure TxtFontSize2Change(Sender: TObject);
    procedure OsdText2Change(Sender: TObject);
    procedure ScrTransparValue1Change(Sender: TObject);
    procedure textRectXChange(Sender: TObject);
    procedure textRectYChange(Sender: TObject);
    procedure textRectWidthChange(Sender: TObject);
    procedure textRectHeightChange(Sender: TObject);
    procedure textRectLineSizeChange(Sender: TObject);
    procedure textCrossYChange(Sender: TObject);
    procedure textCrossXWidthChange(Sender: TObject);
    procedure textCrossYWidthChange(Sender: TObject);
    procedure textCrossLineSizeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OsdSettingDlg: TOsdSettingDlg;
  OpenFileDlg:Boolean ;

implementation
 uses GlobalVar,DxMediaFunction,DxMediaApi, Unit1;
{$R *.dfm}

procedure TOsdSettingDlg.TimeSetColorClick(Sender: TObject);
begin
      ColorDialog1.Execute ;
      DeviceOsdInfo[1].TimeColor:=ColorDialog1.Color;
end;

procedure TOsdSettingDlg.TxtSetColor1Click(Sender: TObject);
begin
      ColorDialog1.Execute ;

        DeviceOsdInfo[1].TextColor:=ColorDialog1.Color;
end;

procedure TOsdSettingDlg.OKBtnClick(Sender: TObject);
begin

           //ʱosd
       If TimeOsd.Checked =True then
       begin
              if TimeTranspar.Checked=True then
              begin

                  DXSetTimeOSD( DeviceInfo[CardNo].dwChannelHandle,
                                  DeviceOsdInfo[1].TimeX,
                                 DeviceOsdInfo[1].TimeY,
                                 DeviceOsdInfo[1].TimeFontSizeVal,
                                 PAnsiChar('Arial'),
                                 DeviceOsdInfo[1].TimeColor,
                                 DeviceOsdInfo[1].BackColor,
                                 True);


                 SettingIni.WriteString('OSDSetting','TimeTranspar', 'True');
              end

              else
              begin
                 DXSetTimeOSD(DeviceInfo[CardNo].dwChannelHandle,
                                 DeviceOsdInfo[1].TimeX,
                                 DeviceOsdInfo[1].TimeY,
                                 DeviceOsdInfo[1].TimeFontSizeVal,
                                 PAnsiChar('Arial'),
                                 DeviceOsdInfo[1].TimeColor,
                                 DeviceOsdInfo[1].BackColor,
                                 false);
                 SettingIni.WriteString('OSDSetting','TimeTranspar', 'False');
              end;
               DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,0,0,true);
                SettingIni.WriteString('OSDSetting','TimeOsdEnable', 'True');


       end
       else
       begin
          //   DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,0,0,false);
               SettingIni.WriteString('OSDSetting','TimeOsdEnable', 'False');

       end;

        //õһıosd
       If TextOsd1.Checked = True Then
       begin
             If TextTranspar1.Checked = True Then
             begin
                   DXSetTextOSD(DeviceInfo[CardNo].dwChannelHandle,
                                 DeviceOsdInfo[1].TxtPlaceX,
                                 DeviceOsdInfo[1].TxtPlaceY,
                                 0,
                                 PAnsiChar(AnsiString(DeviceOsdInfo[1].Osd_Txt)),
                                 DeviceOsdInfo[1].TxtFontSizeVal,
                                 PAnsiChar('Arial'),
                                 DeviceOsdInfo[1].TextColor ,
                                 DeviceOsdInfo[1].BackColor,
                                 true);

                    SettingIni.WriteString('OSDSetting','TextTranspar1', 'True')
             end
             else
             begin
                  DXSetTextOSD(DeviceInfo[CardNo].dwChannelHandle,
                                 DeviceOsdInfo[1].TxtPlaceX,
                                 DeviceOsdInfo[1].TxtPlaceY,
                                 0,
                                 PAnsiChar(AnsiString(DeviceOsdInfo[1].Osd_Txt)),
                                 DeviceOsdInfo[1].TxtFontSizeVal,
                                 PAnsiChar('Arial'),
                                 DeviceOsdInfo[1].TextColor ,
                                 DeviceOsdInfo[1].BackColor,
                                 false);
                                 SettingIni.WriteString('OSDSetting','TextTranspar1', 'False')
             end;
              DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,1,0,true);
                SettingIni.WriteString('OSDSetting','TextOsdEnable1', 'True');
       end
       Else
       begin
        //  DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,1,0,false);
          SettingIni.WriteString('OSDSetting','TextOsdEnable1', 'False');
       End ;

         //õڶıosd
       If TextOsd2.Checked = True Then
       begin
             If TextTranspar2.Checked = True Then
             begin
                   DXSetTextOSD(DeviceInfo[CardNo].dwChannelHandle,
                                  DeviceOsdInfo[2].TxtPlaceX,
                                  DeviceOsdInfo[2].TxtPlaceY,
                                 1,
                                 PAnsiChar(AnsiString( DeviceOsdInfo[2].Osd_Txt)),
                                  DeviceOsdInfo[2].TxtFontSizeVal,
                                  PAnsiChar('Arial'),
                                  DeviceOsdInfo[2].TextColor ,
                                  DeviceOsdInfo[1].BackColor,
                                 true);
                                   SettingIni.WriteString('OSDSetting','TextTranspar2', 'True');


             end
             else
             begin
                  DXSetTextOSD(DeviceInfo[CardNo].dwChannelHandle,
                                  DeviceOsdInfo[2].TxtPlaceX,
                                  DeviceOsdInfo[2].TxtPlaceY,
                                 1,
                                 PAnsiChar(AnsiString( DeviceOsdInfo[2].Osd_Txt)),
                                  DeviceOsdInfo[2].TxtFontSizeVal,
                                 PAnsiChar('Arial'),
                                  DeviceOsdInfo[2].TextColor ,
                                  DeviceOsdInfo[1].BackColor,
                                 false);
                                  SettingIni.WriteString('OSDSetting','TextTranspar2', 'False');
             end;
              DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,1,1,true);
              SettingIni.WriteString('OSDSetting','  TextOsdEnable2', 'True');

           end
       Else
       begin
         // DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,1,1,false);
           SettingIni.WriteString('OSDSetting','  TextOsdEnable2', 'False');
       End ;
       //ͼƬosd
       if PicOsd1.Checked =True then
       begin
             if OpenFileDlg=False then
             begin
                   ShowMessage('Please select picture file');
                   Exit;
             end
             else
             begin

                    DXSetPictureOSD(DeviceInfo[CardNo].dwChannelHandle,
                                                DeviceOsdInfo[1].PicPlaceX,
                                                DeviceOsdInfo[1].PicPlaceY,
                                               0,
                                               PAnsiChar(AnsiString( DeviceOsdInfo[1].PicOsdFile)),
                                               True,
                                                DeviceOsdInfo[1].PicAlphaValue );

                        DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,2,0,true);
             end;
       end
       else
       begin
           // DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,2,0,false );
       end;

      ///////////////////////
         if (checkDrawRect.Checked = true)  then
         begin
                     //set picture osd parameter, disable transparent
                     DXSetRectOSD(DeviceInfo[CardNo].dwChannelHandle,
                                             DeviceOsdInfo[1].RectX,
                                             DeviceOsdInfo[1].RectY,
                                             DeviceOsdInfo[1].RectWidth,
                                             DeviceOsdInfo[1].RectHeight,
                                            0,
                                            DeviceOsdInfo[1].RectLineSizeVal,
                                            DeviceOsdInfo[1].RectLineStyle,
                                             DeviceOsdInfo[1].RectLineColor,
                                            255);

                     DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                           4,
                                           0,
                                           true);
        end
        else
        begin

                       DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                            4,
                                            0,
                                            false);
        end;


        if (checkCrossLine.Checked = true) then
         begin
                     //set cross line osd parameter, disable transparent
                     //line 1
                     DXSetLineOSD(DeviceInfo[CardNo].dwChannelHandle,
                                            DeviceOsdInfo[1].LineX0,
                                            DeviceOsdInfo[1].LineY0,
                                            DeviceOsdInfo[1].LineX1,
                                             DeviceOsdInfo[1].LineY1,
                                            0,
                                            DeviceOsdInfo[1].LineSizeVal,
                                             DeviceOsdInfo[1].RectLineStyle,
                                             DeviceOsdInfo[1].LineColor,
                                             255);
                      DXSetLineOSD(DeviceInfo[CardNo].dwChannelHandle,
                                            DeviceOsdInfo[2].LineX0,
                                            DeviceOsdInfo[2].LineY0,
                                            DeviceOsdInfo[2].LineX1,
                                             DeviceOsdInfo[2].LineY1,
                                            1,
                                            DeviceOsdInfo[2].LineSizeVal,
                                            DeviceOsdInfo[1].LineStyle,
                                            DeviceOsdInfo[1].LineColor,
                                            255);


                     DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                           3,
                                           0,
                                           true);

                     DxMediaApi.DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                          3,
                                          1,
                                          true);
             end
             else
             begin

                     DxMediaApi.DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                            3,
                                            0,
                                            false);
                     DxMediaApi.DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,
                                           3,
                                           1,
                                           false);
        end;





      ///////

end;

procedure TOsdSettingDlg.TimePlaceXChange(Sender: TObject);
begin

         DeviceOsdInfo[1].TimeX:=StrToInt(TimePlaceX.Text);
        SettingIni.WriteInteger('OSDSetting','TimeX', DeviceOsdInfo[1].TimeX);
end;

procedure TOsdSettingDlg.TimePlaceYChange(Sender: TObject);
begin
       DeviceOsdInfo[1].TimeY:=StrToInt(TimePlaceY.Text);
      SettingIni.WriteInteger('OSDSetting','TimeY',DeviceOsdInfo[1].TimeY);
     
end;

procedure TOsdSettingDlg.TimeFontSizeChange(Sender: TObject);
begin
         DeviceOsdInfo[1].TimeFontSizeVal:=StrToInt(TimeFontSize .Text );
      SettingIni.WriteInteger('OSDSetting','TimeFontSize',  DeviceOsdInfo[1].TimeFontSizeVal);

end;

procedure TOsdSettingDlg.FormCreate(Sender: TObject);
begin
      OpenFileDlg:=False;


        DeviceOsdInfo[1].TimeColor:=RGB(0,255,0);
        DeviceOsdInfo[1].TextColor:=RGB(0,255,0);
         DeviceOsdInfo[2].TextColor:=RGB(0,255,0);
        DeviceOsdInfo[1].BackColor:=RGB(255,255,255);
        DeviceOsdInfo[1].TxtFontSizeVal:=StrToInt(TxtFontSize1.Text );
        DeviceOsdInfo[2].TxtFontSizeVal:=StrToInt(TxtFontSize2.Text );
        DeviceOsdInfo[1].Osd_Txt:=OsdText1.Text ;
         DeviceOsdInfo[2].Osd_Txt:=OsdText2.Text ;
        DeviceOsdInfo[1].TxtPlaceX:=StrToInt(TextPlaceX1.Text );
        DeviceOsdInfo[1].TxtPlaceY:=StrToInt(TextPlaceY1.Text );
         DeviceOsdInfo[2].TxtPlaceX:=StrToInt(TextPlaceX2.Text );
        DeviceOsdInfo[2].TxtPlaceY:=StrToInt(TextPlaceY2.Text );
        DeviceOsdInfo[1].TimeX:=StrToInt(TimePlaceX.Text);
        DeviceOsdInfo[1].TimeY:=StrToInt(TimePlaceY.Text);
        DeviceOsdInfo[1].PicPlaceX:=StrToInt(PictPlaceX1.Text );
        DeviceOsdInfo[1].PicPlaceY:=StrToInt(PictPlaceY1.Text );
        DeviceOsdInfo[2].PicPlaceX:=StrToInt(PictPlaceX2.Text );
        DeviceOsdInfo[2].PicPlaceY:=StrToInt(PictPlaceY2.Text );
        DeviceOsdInfo[1].TimeFontSizeVal:=StrToInt(TimeFontSize .Text );


        DeviceOsdInfo[1].RectX :=StrToInt(textRectX.Text);
        DeviceOsdInfo[1].RectY:=StrToInt(textRectY.Text);
        DeviceOsdInfo[1].RectWidth:=StrToInt(textRectWidth.Text );
        DeviceOsdInfo[1].RectHeight:=StrToInt(textRectHeight.Text );
        DeviceOsdInfo[1].RectLineSizeVal:=StrToInt(textRectLineSize.Text);
        DeviceOsdInfo[1].RectLineStyle:=style_solid;
        DeviceOsdInfo[1].RectLineColor:=RGB(255,0,0);

        DeviceOsdInfo[1].LineX0 :=StrToInt(textCrossX.Text)-trunc(StrToInt(textCrossXWidth.Text)/2);
        DeviceOsdInfo[1].LineY0:=StrToInt(textCrossY.Text);
        DeviceOsdInfo[1].LineX1:=StrToInt(textCrossX.Text)+trunc(StrToInt(textCrossXWidth.Text)/2);
        DeviceOsdInfo[1].LineY1:=StrToInt(textCrossY.Text );
        DeviceOsdInfo[1].LineSizeVal:=StrToInt(textCrossLineSize.Text);
        DeviceOsdInfo[1].LineStyle:=style_solid;
        DeviceOsdInfo[1].LineColor:=RGB(255,0,0);


        DeviceOsdInfo[2].LineX0 :=StrToInt(textCrossX.Text);
        DeviceOsdInfo[2].LineY0:=StrToInt(textCrossY.Text)-trunc(StrToInt(textCrossYWidth.Text)/2);
        DeviceOsdInfo[2].LineX1:=StrToInt(textCrossX.Text);
        DeviceOsdInfo[2].LineY1:=StrToInt(textCrossY.Text)+trunc(StrToInt(textCrossYWidth.Text)/2);
        DeviceOsdInfo[2].LineSizeVal:=StrToInt(textCrossLineSize.Text);
        DeviceOsdInfo[2].LineStyle:=style_solid;
        DeviceOsdInfo[2].LineColor:=RGB(255,0,0);


       ScrTransparValue1.Max :=255;
       ScrTransparValue1.Min :=0;
        ScrTransparValue1.Position :=128;
       ScrTransparValue2.Max :=255;
       ScrTransparValue2.Min :=0;
       ScrTransparValue2.Position :=0;


         DeviceOsdInfo[1].PicAlphaValue:=ScrTransparValue1.Position;
          DeviceOsdInfo[2].PicAlphaValue:=ScrTransparValue2.Position;
    //  PicAlphaValue[1]:= Char (ScrTransparValue2.Position);

    TextOsd1.Checked :=True;
    TextOsd2.Checked :=True;
    TextTranspar1.Checked:=True;
    TextTranspar2.Checked:=True;
    TimeOsd.Checked:=True;
    TimeTranspar.Checked:=True;




end;

procedure TOsdSettingDlg.TxtFontSize1Change(Sender: TObject);
begin
       DeviceOsdInfo[1].TxtFontSizeVal:=StrToInt(TxtFontSize1.Text );
     SettingIni.WriteInteger('OSDSetting','TxtFontSize1', DeviceOsdInfo[1].TxtFontSizeVal);

end;

procedure TOsdSettingDlg.TextPlaceX1Change(Sender: TObject);
begin
       DeviceOsdInfo[1].TxtPlaceX:=StrToInt(TextPlaceX1.Text );
       SettingIni.WriteInteger('OSDSetting','TxtPlaceX1',DeviceOsdInfo[1].TxtPlaceX);
end;



procedure TOsdSettingDlg.TextPlaceY1Change(Sender: TObject);
begin
     DeviceOsdInfo[1].TxtPlaceY:=StrToInt(TextPlaceY1.Text );
     SettingIni.WriteInteger('OSDSetting','TxtPlaceY1', DeviceOsdInfo[1].TxtPlaceY);
end;

procedure TOsdSettingDlg.PictPlaceX1Change(Sender: TObject);
begin
       DeviceOsdInfo[1].PicPlaceX:=StrToInt(PictPlaceX1.Text );
      SettingIni.WriteInteger('OSDSetting','PicPlaceX1',   DeviceOsdInfo[1].PicPlaceX);
end;

procedure TOsdSettingDlg.PictPlaceY1Change(Sender: TObject);
begin
       DeviceOsdInfo[1].PicPlaceY:=StrToInt(PictPlaceY1.Text );
      SettingIni.WriteInteger('OSDSetting','PicPlaceY1', DeviceOsdInfo[1].PicPlaceY);
end;

procedure TOsdSettingDlg.PicBrowse1Click(Sender: TObject);
var PicStr:string;
begin
       //ļĿ¼
      dlgOpen1.Execute ;
        DeviceOsdInfo[1].PicOsdFile:=dlgOpen1.FileName ;
      PicFilePath1.Text :=     DeviceOsdInfo[1].PicOsdFile;
      PicStr:=rightstr( DeviceOsdInfo[1].PicOsdFile,3);
      if PicStr<> 'bmp' then
      begin
            ShowMessage('please select bmp file');
            exit;
      end;
      OpenFileDlg:=True;
end;

procedure TOsdSettingDlg.CancelBtnClick(Sender: TObject);
begin
        OsdSettingDlg.Close ;
end;

procedure TOsdSettingDlg.PictPlaceX2Change(Sender: TObject);
begin
          DeviceOsdInfo[2].PicPlaceX:=StrToInt(PictPlaceX2.Text );
          SettingIni.WriteInteger('OSDSetting','PicPlaceX2',  DeviceOsdInfo[2].PicPlaceX);

end;

procedure TOsdSettingDlg.PictPlaceY2Change(Sender: TObject);
begin
            DeviceOsdInfo[2].PicPlaceY:=StrToInt(PictPlaceY2.Text );
             SettingIni.WriteInteger('OSDSetting','PicPlaceY1', DeviceOsdInfo[2].PicPlaceY);
end;

procedure TOsdSettingDlg.TextPlaceX2Change(Sender: TObject);
begin
              DeviceOsdInfo[2].TxtPlaceX:=StrToInt(TextPlaceX2.Text );
              SettingIni.WriteInteger('OSDSetting','TxtPlaceX2', DeviceOsdInfo[2].TxtPlaceX);
end;

procedure TOsdSettingDlg.TextPlaceY2Change(Sender: TObject);
begin
         DeviceOsdInfo[2].TxtPlaceY:=StrToInt(TextPlaceY2.Text );
      SettingIni.WriteInteger('OSDSetting','TxtPlaceY2',  DeviceOsdInfo[2].TxtPlaceY);
end;

procedure TOsdSettingDlg.TxtFontSize2Change(Sender: TObject);
begin
            DeviceOsdInfo[2].TxtFontSizeVal:=StrToInt(TxtFontSize2.Text );
            SettingIni.WriteInteger('OSDSetting','  TxtFontSize2', DeviceOsdInfo[2].TxtFontSizeVal);
end;

procedure TOsdSettingDlg.OsdText2Change(Sender: TObject);
begin
           DeviceOsdInfo[2].Osd_Txt:=OsdText2.Text ;
           SettingIni.WriteString('OSDSetting','  Osd_Txt2', DeviceOsdInfo[2].Osd_Txt);
end;

procedure TOsdSettingDlg.ScrTransparValue1Change(Sender: TObject);
begin

                        DeviceOsdInfo[1].PicAlphaValue:=ScrTransparValue1.Position;
                     DXSetPictureOSD(DeviceInfo[CardNo].dwChannelHandle,
                                               DeviceOsdInfo[1].PicPlaceX,
                                               DeviceOsdInfo[1].PicPlaceY,
                                               0,
                                               PAnsiChar(AnsiString(DeviceOsdInfo[1].PicOsdFile)),
                                               True,
                                               DeviceOsdInfo[1].PicAlphaValue );

                        DXEnOSDDisp(DeviceInfo[CardNo].dwChannelHandle,2,0,true);
end;

procedure TOsdSettingDlg.textRectXChange(Sender: TObject);
begin
        DeviceOsdInfo[1].RectX :=StrToInt(textRectX.Text);
end;

procedure TOsdSettingDlg.textRectYChange(Sender: TObject);
begin
      
        DeviceOsdInfo[1].RectY:=StrToInt(textRectY.Text);
end;

procedure TOsdSettingDlg.textRectWidthChange(Sender: TObject);
begin
         DeviceOsdInfo[1].RectWidth:=StrToInt(textRectWidth.Text );
end;

procedure TOsdSettingDlg.textRectHeightChange(Sender: TObject);
begin
           DeviceOsdInfo[1].RectHeight:=StrToInt(textRectHeight.Text );
end;

procedure TOsdSettingDlg.textRectLineSizeChange(Sender: TObject);
begin
       
        DeviceOsdInfo[1].RectLineSizeVal:=StrToInt(textRectLineSize.Text);
end;

procedure TOsdSettingDlg.textCrossXChange(Sender: TObject);
begin
              DeviceOsdInfo[2].LineX0 :=StrToInt(textCrossX.Text);
              DeviceOsdInfo[2].LineX1:=StrToInt(textCrossX.Text);
              DeviceOsdInfo[1].LineX0 :=StrToInt(textCrossX.Text)-trunc(StrToInt(textCrossXWidth.Text)/2);
              DeviceOsdInfo[1].LineX1:=StrToInt(textCrossX.Text)+trunc(StrToInt(textCrossXWidth.Text)/2);
end;
procedure TOsdSettingDlg.textCrossYChange(Sender: TObject);
begin
              DeviceOsdInfo[1].LineY0:=StrToInt(textCrossY.Text);
              DeviceOsdInfo[1].LineY1:=StrToInt(textCrossY.Text );
               DeviceOsdInfo[2].LineY0:=StrToInt(textCrossY.Text)-trunc(StrToInt(textCrossYWidth.Text)/2);
              DeviceOsdInfo[2].LineY1:=StrToInt(textCrossY.Text)+trunc(StrToInt(textCrossYWidth.Text)/2);
end;



procedure TOsdSettingDlg.textCrossXWidthChange(Sender: TObject);
begin
              DeviceOsdInfo[1].LineX0 :=StrToInt(textCrossX.Text)-trunc(StrToInt(textCrossXWidth.Text)/2);
              DeviceOsdInfo[1].LineX1:=StrToInt(textCrossX.Text)+trunc(StrToInt(textCrossXWidth.Text)/2);
end;

procedure TOsdSettingDlg.textCrossYWidthChange(Sender: TObject);
begin
              DeviceOsdInfo[2].LineY0:=StrToInt(textCrossY.Text)-trunc(StrToInt(textCrossYWidth.Text)/2);
              DeviceOsdInfo[2].LineY1:=StrToInt(textCrossY.Text)+trunc(StrToInt(textCrossYWidth.Text)/2);
end;

procedure TOsdSettingDlg.textCrossLineSizeChange(Sender: TObject);
begin
        DeviceOsdInfo[1].LineSizeVal:=StrToInt(textCrossLineSize.Text);
        DeviceOsdInfo[2].LineSizeVal:=StrToInt(textCrossLineSize.Text);
end;

end.


    
