// OSDSetting.cpp : implementation file
//

#include "stdafx.h"
#include "dlgDemo.h"
#include "OSDSetting.h"
#include "DXMediaCap.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// OSDSetting dialog


OSDSetting::OSDSetting(CWnd* pParent /*=NULL*/)
	: CDialog(OSDSetting::IDD, pParent)
{
	//{{AFX_DATA_INIT(OSDSetting)
	m_TimeOsdCheck = true;
	m_TxtPlaceY1 = _T("50");
	m_TxtPlaceY2 = _T("100");
	m_TxtPlaceX1 = _T("10");
	m_TxtPlaceX2 = _T("10");
	m_PicPlaceX = _T("50");
	m_PicPlaceY = _T("150");
	m_TimePlaceY = _T("10");
	m_TxtFontSize1 = _T("25");
	m_TxtFontSize2 = _T("25");
	m_TimeFontSize = _T("25");
	m_TxtOSD1 = _T("Camera1");
	m_TxtOSD2 = _T("Camera2");
	m_PicFile = _T("");
	m_TxtTranCheck1 = true;
	m_TxtTranCheck2 = true;
	m_TxtOsdCheck1 =true;
	m_TxtOsdCheck2 = true;
	m_TimeTranCheck =true;
	m_TimePlaceX = _T("10");
	m_Crossx = _T("500");
	m_Crossxwidth = _T("400");
	m_CrossY = _T("250");
	m_CrossYwidth = _T("400");
	m_LineSize = _T("4");
	m_RectLineSize = _T("4");
	m_RectWidth = _T("400");
	m_CrossLineEnable = FALSE;
	m_DrawRectEnable = FALSE;
	m_RectY = _T("250");
	m_RectX = _T("50");
	m_TxtOsdCheck1=true;
	m_TimeTranCheck = true;
	m_TxtOsdCheck1 = true;
	m_DrawRectHeight = _T("400");
	//}}AFX_DATA_INIT
}


void OSDSetting::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(OSDSetting)
	DDX_Control(pDX, IDC_PICTUREOSD_CHECK, m_PicOsdCheck);
	DDX_Check(pDX, IDC_TIMEOSD_CHECK, m_TimeOsdCheck);
	DDX_Text(pDX, IDC_TextPlaceY_EDIT1, m_TxtPlaceY1);
	DDX_Text(pDX, IDC_TextPlaceY_EDIT2, m_TxtPlaceY2);
	DDX_Text(pDX, IDC_TEXTPlaceX_EDIT1, m_TxtPlaceX1);
	DDX_Text(pDX, IDC_TEXTPlaceX_EDIT2, m_TxtPlaceX2);
	DDX_Text(pDX, IDC_PicturePlaceX_EDIT, m_PicPlaceX);
	DDX_Text(pDX, IDC_PicturePlaceY_EDIT, m_PicPlaceY);
	DDX_Text(pDX, IDC_TimePlaceY_EDIT, m_TimePlaceY);
	DDX_Text(pDX, IDC_TextFontSize_EDIT1, m_TxtFontSize1);
	DDX_Text(pDX, IDC_TextFontSize_EDIT3, m_TxtFontSize2);
	DDX_Text(pDX, IDC_TimeFontSize_EDIT1, m_TimeFontSize);
	DDX_Text(pDX, IDC_Texosd_EDIT4, m_TxtOSD1);
	DDX_Text(pDX, IDC_Texosd_EDIT5, m_TxtOSD2);
	DDX_Text(pDX, IDC_PictureFile_EDIT, m_PicFile);
	DDX_Check(pDX, IDC_TEXTTRAN_CHECK1, m_TxtTranCheck1);
	DDX_Check(pDX, IDC_TEXTTRAN_CHECK2, m_TxtTranCheck2);
	DDX_Check(pDX, IDC_TEXTOSD_CHECK1, m_TxtOsdCheck1);
	DDX_Check(pDX, IDC_TEXTOSD_CHECK2, m_TxtOsdCheck2);
	DDX_Check(pDX, IDC_TIMETRAN_CHECK, m_TimeTranCheck);
	DDX_Text(pDX, IDC_TimePlaceX_EDIT, m_TimePlaceX);
	DDX_Text(pDX, IDC_CrossX_EDIT, m_Crossx);
	DDX_Text(pDX, IDC_CrossXWidth_EDIT, m_Crossxwidth);
	DDX_Text(pDX, IDC_CrossY_EDIT, m_CrossY);
	DDX_Text(pDX, IDC_CrossYWidth_EDIT, m_CrossYwidth);
	DDX_Text(pDX, IDC_LineSize_EDIT, m_LineSize);
	DDX_Text(pDX, IDC_RectLineSize_EDIT, m_RectLineSize);
	DDX_Text(pDX, IDC_RectWidth_EDIT, m_RectWidth);
	DDX_Check(pDX, IDC_CrossLine_CHECK, m_CrossLineEnable);
	DDX_Check(pDX, IDC_DRAWRECT_CHECK, m_DrawRectEnable);
	DDX_Text(pDX, IDC_RectY_EDIT, m_RectY);
	DDX_Text(pDX, IDC_RectX_EDIT, m_RectX);
	DDX_Text(pDX, IDC_RectHeight_EDIT, m_DrawRectHeight);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(OSDSetting, CDialog)
	//{{AFX_MSG_MAP(OSDSetting)
	ON_BN_CLICKED(IDC_TIMEOSD_CHECK, OnTimeosdCheck)
	ON_BN_CLICKED(IDC_BUTTON_COLOR2, OnButtonColor2)
	ON_BN_CLICKED(IDC_BUTTON_COLOR3, OnButtonColor3)
	ON_BN_CLICKED(IDC_BUTTON_COLOR1, OnButtonColor1)
	ON_BN_CLICKED(IDC_OPENFILE_BUTTON, OnOpenfileButton)
	ON_EN_CHANGE(IDC_RectX_EDIT, OnChangeRectXEDIT)
	ON_EN_CHANGE(IDC_RectY_EDIT, OnChangeRectYEDIT)
	ON_EN_CHANGE(IDC_RectWidth_EDIT, OnChangeRectWidthEDIT)
	ON_EN_CHANGE(IDC_RectHeight_EDIT, OnChangeRectHeightEDIT)
	ON_EN_CHANGE(IDC_RectLineSize_EDIT, OnChangeRectLineSizeEDIT)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// OSDSetting message handlers

void OSDSetting::OnOK() 
{
	// TODO: Add extra validation here
		
	//time osd place para
	 
	GetDlgItem(IDC_TimePlaceX_EDIT)->GetWindowText( m_TimePlaceX);
	GetDlgItem(IDC_TimePlaceY_EDIT)->GetWindowText( m_TimePlaceY);
    TosdInfo[1].TimeX=atoi(m_TimePlaceX);
	TosdInfo[1].TimeY=atoi(m_TimePlaceY);
	// txt osd place para

	GetDlgItem(IDC_TEXTPlaceX_EDIT1)->GetWindowText( m_TxtPlaceX1);
	GetDlgItem(IDC_TEXTPlaceX_EDIT2)->GetWindowText( m_TxtPlaceX2);
	GetDlgItem(IDC_TextPlaceY_EDIT1)->GetWindowText( m_TxtPlaceY1);
	GetDlgItem(IDC_TextPlaceY_EDIT2)->GetWindowText( m_TxtPlaceY2);
	TosdInfo[1].TxtPlaceX=atoi(m_TxtPlaceX1);
	TosdInfo[2].TxtPlaceX=atoi(m_TxtPlaceX2);
	TosdInfo[1].TxtPlaceY=atoi(m_TxtPlaceY1);
	TosdInfo[2].TxtPlaceY=atoi(m_TxtPlaceY2);
	//picture osd place para

	GetDlgItem(IDC_PicturePlaceX_EDIT)->GetWindowText( m_PicPlaceX);
	GetDlgItem(IDC_PicturePlaceY_EDIT)->GetWindowText( m_PicPlaceY);
	TosdInfo[1].PicPlaceX=atoi(m_PicPlaceX);
	TosdInfo[1].PicPlaceY=atoi(m_PicPlaceY);

	GetDlgItem(IDC_TimeFontSize_EDIT1)->GetWindowText( m_TimeFontSize);
	GetDlgItem(IDC_TextFontSize_EDIT1)->GetWindowText( m_TxtFontSize1);
	GetDlgItem(IDC_TextFontSize_EDIT2)->GetWindowText( m_TxtFontSize2);

	TosdInfo[1].TimeFontSizeVal=atoi(m_TimeFontSize);
	TosdInfo[1].TxtFontSizeVal=atoi(m_TxtFontSize1);
	TosdInfo[2].TxtFontSizeVal=atoi(m_TxtFontSize2);


     //osd color setting
	TosdInfo[1].TxtColor=RGB(0,255,0);
	TosdInfo[2].TxtColor=RGB(0,255,0);
	TosdInfo[1].TimeColor=RGB(0,255,0);
	TosdInfo[1].BackColor =RGB(0,0,0);
	TosdInfo[1].LineColor=RGB(0,255,0);
	TosdInfo[2].LineColor=RGB(0,255,0);
	TosdInfo[1].RectLineColor=RGB(0,255,0);
	

 	 CString OsdTxt1,OsdTxt2;
	 GetDlgItem(IDC_Texosd_EDIT4)->GetWindowText( m_TxtOSD1);
	 GetDlgItem(IDC_Texosd_EDIT4)->GetWindowText( m_TxtOSD2);
	 TosdInfo[1].Osd_Txtstring=(LPSTR)(LPCTSTR)m_TxtOSD1;
	 TosdInfo[2].Osd_Txtstring=(LPSTR)(LPCTSTR)m_TxtOSD2;



	TosdInfo[1].TxtFont=	TEXT("Arial");
	TosdInfo[2].TxtFont=	TEXT("Arial");
	TosdInfo[1].TimeFont=TEXT("Arial");


	//draw rect para

	GetDlgItem(IDC_RectX_EDIT)->GetWindowText(m_RectX);
	GetDlgItem(IDC_RectY_EDIT)->GetWindowText(m_RectY);
	GetDlgItem(IDC_RectWidth_EDIT)->GetWindowText( m_RectWidth);
	GetDlgItem(IDC_RectHeight_EDIT)->GetWindowText( m_DrawRectHeight);
	GetDlgItem(IDC_RectLineSize_EDIT)->GetWindowText( m_RectLineSize);

	TosdInfo[1].RectX=atoi(m_RectX);
	TosdInfo[1].RectY=atoi(m_RectY);
	TosdInfo[1].RectWidth=atoi(m_RectWidth);
	TosdInfo[1].RectHeight=atoi(m_DrawRectHeight);
	TosdInfo[1].RectLineSizeVal=atoi(m_RectLineSize);

/////Cross line osd para
	GetDlgItem(IDC_CrossX_EDIT)->GetWindowText( m_Crossx);
	GetDlgItem(IDC_CrossY_EDIT)->GetWindowText( m_CrossY);
	GetDlgItem(IDC_CrossXWidth_EDIT)->GetWindowText( m_Crossxwidth);
	GetDlgItem(IDC_CrossYWidth_EDIT)->GetWindowText( m_CrossYwidth);
	GetDlgItem(IDC_LineSize_EDIT)->GetWindowText( m_LineSize);

	TosdInfo[1].LineX0=atoi(m_Crossx)-atoi(m_Crossxwidth)/2;
	TosdInfo[1].LineX1=atoi(m_Crossx)+ atoi(m_Crossxwidth)/2;
	TosdInfo[1].LineY0=atoi(m_CrossY);
	TosdInfo[1].LineY1=atoi(m_CrossY);
	TosdInfo[1].LineSizeVal=atoi(m_RectLineSize);

	TosdInfo[2].LineX0=atoi(m_Crossx);
	TosdInfo[2].LineX1=atoi(m_Crossx);
	TosdInfo[2].LineY0=atoi(m_CrossY)-atoi(m_CrossYwidth)/2;
	TosdInfo[2].LineY1=atoi(m_CrossY)+ atoi(m_CrossYwidth)/2;
	TosdInfo[2].LineSizeVal=atoi(m_RectLineSize);


	///
	// time osd setting
	
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TIMEOSD_CHECK))->GetCheck())
	{
			if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TIMETRAN_CHECK))->GetCheck())
			{
				//time osd setting
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											0,
											0,
											TosdInfo[1].Osd_Txtstring,
											TosdInfo[1].TimeX,
											TosdInfo[1].TimeY,
											TosdInfo[1].TimeFontSizeVal,
											TosdInfo[1].TimeFont,
											TosdInfo[1].TimeColor,
											TosdInfo[1].BackColor ,
											true,
											255);
										   
				
				
				
			}
			else
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											0,
											0,
											TosdInfo[1].Osd_Txtstring,
											TosdInfo[1].TimeX,
											TosdInfo[1].TimeY,
											TosdInfo[1].TimeFontSizeVal,
											TosdInfo[1].TimeFont,
											TosdInfo[1].TimeColor,
											TosdInfo[1].BackColor ,
											false,
											255);
			}
			//enable time osd 
	
			m_DeviceControl.StartOsd(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,0,0,true);
			
	}
	else

	{
			//cancel time osd
		m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,0,0,false);
		
	}

	    //text1 osd setting
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TEXTOSD_CHECK1))->GetCheck())
	{
		
			if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TEXTTRAN_CHECK1))->GetCheck())
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											1,
											0,
											TosdInfo[1].Osd_Txtstring,
											TosdInfo[1].TxtPlaceX,
											TosdInfo[1].TxtPlaceY,
											TosdInfo[1].TxtFontSizeVal,
											TosdInfo[1].TxtFont,
											TosdInfo[1].TxtColor ,
											TosdInfo[1].BackColor ,
											true,
											255);
			}
			else
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											1,
											0,
											TosdInfo[1].Osd_Txtstring,
											TosdInfo[1].TxtPlaceX,
											TosdInfo[1].TxtPlaceY,
											TosdInfo[1].TxtFontSizeVal,
											TosdInfo[1].TxtFont,
											TosdInfo[1].TxtColor ,
											TosdInfo[1].BackColor ,
											false,
											255);
			}
			//enable txt1 osd 
			m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,1,0,true);

	}
	else

	{
			
			//enable txt1 osd 
		m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,1,0,false);
	}
		
			//text2 osd setting
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TEXTOSD_CHECK2))->GetCheck())
	{
			
			if(BST_CHECKED==((CButton*)GetDlgItem(IDC_TEXTTRAN_CHECK2))->GetCheck())
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											1,
											1,
											TosdInfo[2].Osd_Txtstring,
											TosdInfo[2].TxtPlaceX,
											TosdInfo[2].TxtPlaceY,
											TosdInfo[2].TxtFontSizeVal,
											TosdInfo[2].TxtFont,
											TosdInfo[2].TxtColor ,
											TosdInfo[2].BackColor ,
											true,
											255);
			}
			else
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											1,
											1,
											TosdInfo[2].Osd_Txtstring,
											TosdInfo[2].TxtPlaceX,
											TosdInfo[2].TxtPlaceY,
											TosdInfo[2].TxtFontSizeVal,
											TosdInfo[2].TxtFont,
											TosdInfo[2].TxtColor ,
											TosdInfo[2].BackColor ,
											false,
											255);
			}
				//enable txt2 osd 
			m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,1,1,true);
	}
	else

	{


			//enable txt2 osd 
		m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,1,1,false);
	}
	//picture osd setting
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_PICTUREOSD_CHECK))->GetCheck())
	{
			if(BST_CHECKED==((CButton*)GetDlgItem(IDC_PICTUREOSD_CHECK))->GetCheck())
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											2,
											0,
											TosdInfo[1].PicOsdFile,
											TosdInfo[1].PicPlaceX,
											TosdInfo[1].PicPlaceY,
											TosdInfo[1].TxtFontSizeVal,
											TosdInfo[1].TxtFont,
											TosdInfo[1].TxtColor ,
											TosdInfo[1].BackColor ,
											true,
											80);
			}
			else
			{
				m_DeviceControl.SetOSDPara(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											2,
											0,
											TosdInfo[1].PicOsdFile,
											TosdInfo[1].PicPlaceX,
											TosdInfo[1].PicPlaceY,
											TosdInfo[1].TxtFontSizeVal,
											TosdInfo[1].TxtFont,
											TosdInfo[1].TxtColor ,
											TosdInfo[1].BackColor ,
											false,
											0);
			}

				m_DeviceControl.StartOsd (CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,2,0,true);
	}
	///  draw rect osd enable
		if(BST_CHECKED==((CButton*)GetDlgItem(IDC_DRAWRECT_CHECK))->GetCheck())
	{
		
			                   DXSetRectOSD(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
											TosdInfo[1].RectX,
											TosdInfo[1].RectY,
											TosdInfo[1].RectWidth,
											TosdInfo[1].RectHeight,
											0,
											TosdInfo[1].RectLineSizeVal,
											style_solid,
									    	TosdInfo[1].RectLineColor,
											255);
                  /////


							   /////enable the rect osd
                            DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   4,
									   0,
									   true);
			
		}
		else
		{
			 //disable the rect osd
			  DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   4,
									   0,
									   false);

		}

	///////cross line osd

	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_CrossLine_CHECK))->GetCheck())
	{
						//line 1
			         DXSetLineOSD(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
								TosdInfo[1].LineX0,
								TosdInfo[1].LineY0,
								TosdInfo[1].LineX1,
								TosdInfo[1].LineY1,
								0,
								TosdInfo[1].LineSizeVal,
								style_solid,
								TosdInfo[1].LineColor,
								255);
                     //line 2
                    DXSetLineOSD(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
								TosdInfo[2].LineX0,
								TosdInfo[2].LineY0,
								TosdInfo[2].LineX1,
								TosdInfo[2].LineY1,
								1,
								TosdInfo[2].LineSizeVal,
								style_solid,
								TosdInfo[2].LineColor,
								255);

					        //enable line 1 osd
                            DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   3,
									   0,
									   true);

							      //enable line 2 osd
							 DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   3,
									   1,
									   true);
			
		}
		else
		{
			   //disable line 1 osd
			    DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   3,
									   0,
									   false);
				// //disable line2 osd
				 DXEnOSDDisp(CDlgDemoDlg::DeviceInfo[dwCard].dwChannelHandle,
									   3,
									   1,
									   false);
			

		}



		//////
//	CDialog::OnOK();
}

void OSDSetting::OnTimeosdCheck() 
{
	// TODO: Add your control notification handler code here
	
}

BOOL OSDSetting::OnInitDialog() 
{
	CDialog::OnInitDialog();





	
	








	



	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void OSDSetting::OnButtonColor2() 
{
	// TODO: Add your control notification handler code here
	CColorDialog dlgOSDColor(TosdInfo[1].TxtColor, CC_RGBINIT, NULL);

	//TXT OSD 1 COLOR PARA
	if (dlgOSDColor.DoModal() == IDOK)
	{
		TosdInfo[1].TxtColor = dlgOSDColor.GetColor();
	}
}

void OSDSetting::OnButtonColor3() 
{
	// TODO: Add your control notification handler code here
		CColorDialog dlgOSDColor(TosdInfo[2].TxtColor, CC_RGBINIT, NULL);

	if (dlgOSDColor.DoModal() == IDOK)
	{
		TosdInfo[2].TxtColor = dlgOSDColor.GetColor();
	}
}

void OSDSetting::OnButtonColor1() 
{
	// TODO: Add your control notification handler code here
	CColorDialog dlgOSDColor(TosdInfo[dwCard].TimeColor, CC_RGBINIT, NULL);

	//time osd color para
	if (dlgOSDColor.DoModal() == IDOK)
	{
		TosdInfo[dwCard].TimeColor = dlgOSDColor.GetColor();
	}
}

void OSDSetting::OnOpenfileButton() 
{
	// TODO: Add your control notification handler code here
		CString m_FilePath;
	  CFileDialog OpenFiledlg(true ,NULL,NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,NULL,NULL);
	   if(OpenFiledlg.DoModal()==IDOK)   
     { 
			   m_FilePath = OpenFiledlg.GetPathName();////////ȡļ· 
		
			  UpdateData(FALSE); 
     } 
	 	TosdPara[0].PicOsdFile=(LPSTR)(LPCTSTR)m_FilePath;
		GetDlgItem(IDC_PictureFile_EDIT)->SetWindowText(m_FilePath);
	   
}

void OSDSetting::OnChangeRectXEDIT() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_RectX_EDIT)->GetWindowText(m_RectX);
	TosdInfo[1].RectX=atoi(m_RectX);
	
}

void OSDSetting::OnChangeRectYEDIT() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		GetDlgItem(IDC_RectY_EDIT)->GetWindowText(m_RectY);
		TosdInfo[1].RectY=atoi(m_RectY);
	
}

void OSDSetting::OnChangeRectWidthEDIT() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		GetDlgItem(IDC_RectWidth_EDIT)->GetWindowText( m_RectWidth);
		TosdInfo[1].RectWidth=atoi(m_RectWidth);
}

void OSDSetting::OnChangeRectHeightEDIT() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	

	GetDlgItem(IDC_RectHeight_EDIT)->GetWindowText( m_DrawRectHeight);
			

	TosdInfo[1].RectHeight=atoi(m_DrawRectHeight);
	
}

void OSDSetting::OnChangeRectLineSizeEDIT() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
		GetDlgItem(IDC_RectLineSize_EDIT)->GetWindowText( m_RectLineSize);
			TosdInfo[1].RectLineSizeVal=atoi(m_RectLineSize);
	
}

	







