#pragma once

#include <vector>

// CMP4CutDlg dialog

class CMP4CutDlg : public CDialogEx
{
	DECLARE_DYNAMIC(CMP4CutDlg)

public:
	CMP4CutDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CMP4CutDlg();

// Dialog Data
	enum { IDD = IDD_MP4FILECUT_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedBrowse();
	afx_msg void OnBnClickedAdd();
	afx_msg void OnBnClickedDelete();
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedSave();
	afx_msg void OnBnClickedPicbrowse();
	virtual BOOL OnInitDialog();
	afx_msg void OnBnClickedStyle();
	afx_msg void OnDestroy();

private:

	void ListSliceDelete(int index);

	LONGLONG m_nBeginTime;
	LONGLONG m_nEndTime;
	CListBox m_List;
	TEXTFONTINFO m_FontInfo;

	std::vector<MP4FileSlice> m_Slice;
};
