// MP4RepairDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VcDemo.h"
#include "MP4RepairDlg.h"
#include "afxdialogex.h"


// CMP4RepairDlg dialog

IMPLEMENT_DYNAMIC(CMP4RepairDlg, CDialogEx)

CMP4RepairDlg::CMP4RepairDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CMP4RepairDlg::IDD, pParent)
	, m_MP4FileName(_T(""))
	, m_MP4SaveName(_T(""))
{

}

CMP4RepairDlg::~CMP4RepairDlg()
{
}

void CMP4RepairDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MP4_LIST, m_FileList);
}


BEGIN_MESSAGE_MAP(CMP4RepairDlg, CDialogEx)
	ON_BN_CLICKED(IDC_SAVE_BROWSE, &CMP4RepairDlg::OnBnClickedSaveBrowse)
	ON_BN_CLICKED(IDOK, &CMP4RepairDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CMP4RepairDlg message handlers


void CMP4RepairDlg::OnBnClickedSaveBrowse()
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg(FALSE, _T(".mp4"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("MP4 Files|*.mp4||"));
	if (dlg.DoModal() == IDOK)
	{
		SetDlgItemText(IDC_REPAIR_SAVE, dlg.GetPathName());
	}
}


void CMP4RepairDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	int index = m_FileList.GetCurSel();
	if (LB_ERR != index)
	{
		m_FileList.GetText(index, m_MP4FileName);
	}

	GetDlgItemText(IDC_REPAIR_SAVE, m_MP4SaveName);
	CDialogEx::OnOK();
}


BOOL CMP4RepairDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  Add extra initialization here
	CString str = INI_READ_STRING(INI_SAVE_SECTION, INI_FILE_SAVE_DIR, DEFAULT_FILE_SAVE_DIR);
	str += _T("\\Rec\\*.mp4.mix");

	CFileFind mixFind;
	BOOL bSuccess = mixFind.FindFile(str);
	while (bSuccess)
	{
		bSuccess = mixFind.FindNextFile();
		str = mixFind.GetFilePath();
		int nLen = str.ReverseFind('.'); /* remove ".mix" */
		if (nLen != -1)
		{
			m_FileList.AddString(str.Left(nLen));
		}
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
