/********************************************************************
************************************************/

#ifndef __LIBDXCAP_DATASTRU__20110805__
#define __LIBDXCAP_DATASTRU__20110805__

typedef void* device_handle;
typedef void* image_handle;
typedef void* dxmp4_handle;
typedef void* scale_handle;

#define   WM_SAMPLER_CHANGED     ( WM_APP+100 )
#define   WM_PREVIEW_UPDATE      ( WM_APP+1000 )

// Ƶɫռ
enum {cs_rgb24, cs_rgb32, cs_yuy2};
enum {dp_overlay,dp_vmr9,dp_d3d};

// 豸Ϣ
#define MAX_DEVICE_NAME		128
typedef struct _device_tag
{
	unsigned	idx;							// öٹе
	char		deviceName[MAX_DEVICE_NAME];	// 
} DEVICE_TAG, *PDEVICE_TAG;

typedef struct _videocaps
{
	int width;
	int height;
}VIDEOCAPS, *PVIDEOCAPS;

//----Ƶ----------------------
#define INTEL264CODEC_FILTER "intelH264 Codec\0"
#define X264CODEC_FILTER "x264 Codec\0"
#define XVIDCODEC_FILTER "xvid Codec\0"
#define NVIDIACODEC_FILTER "nvidia Codec\0"

#define AAC_FILTER       "aac Codec\0"
#define SYS_FILTER       "sys Codec\0"

enum {codec_sys,codec_intel264,codec_x264,codec_xvid,codec_nvidia};
enum {acodec_sys,acodec_aac};
enum {codec_CBR=0, codec_VBR=1};
typedef struct{
	int fps;    //֡
	int keyframeinterval;  //ؼ֡ڵ֡
	int rcMode;   //ʿ:codec_CBR(ƽ)/codec_VBR(㶨)
	int Quality; //codec_VBR: 0 ~ 51 (ĬֵΪ32)ֵԽЧԽļԽ
	int Bitrate; //codec_CBRʣλkbpsĬֵ256x264Ϊ0ʱڲԼ

	int Maxrbps;  //codec_CBRЧĬֵ4000,λʷΧ:56bps ~ 10Mbps; λKbps
	int Peekbps;  //codec_CBRЧĬֵ1000bps,λʷΧ:56bps ~ 10Mbps; λKbps
}VidCodecPara;
//-------------------------------------------

enum{FILE_AVI=1,FILE_MP4=2};

enum {drate_color};
typedef struct{
	int nBrightness; // ȣȡֵ(-255255)
	int nContrast;  //Աȶȣȡֵ(-100100)
}DRateColorPara;

enum SwsAlogrithm
{
	SWS_SA_FAST_BILINEAR	= 0,
	SWS_SA_BILINEAR			,
	SWS_SA_BICUBIC			,
	SWS_SA_X				,
	SWS_SA_POINT			,
	SWS_SA_AREA				,
	SWS_SA_BICUBLIN			,
	SWS_SA_GAUSS			,
	SWS_SA_SINC				,
	SWS_SA_LANCZOS			,
	SWS_SA_SPLINE			,
};

typedef struct{
	unsigned int src_stride;
	unsigned int src_width;
	unsigned int src_height;
	unsigned int dst_stride;
	unsigned int dst_width;
	unsigned int dst_height;
	SwsAlogrithm algorithm;
}VidScalePara;

//----紫----------------------
enum {net_crtsp,net_crtmp,net_all};
enum {data_vid,data_aud};
typedef struct{
	short port;//rtsp˿(ĬΪ554)
	char  crtmp_uri[MAX_PATH];  //rtmpַ
}NetTransPara,*PNetTransPara;
//-------------------------------------------

enum {style_solid,style_dash,style_dot,style_dashdot};

enum {PropertyPage_VideoCapureFilter, PropertyPage_VideoCapurePin, PropertyPage_VideoCrossbar};

typedef struct {
	int x, y; // 
	int picOpacity; // ͼƬ͸ȣ0 ~ 255255͸
	const char *picFileName; // ͼƬ·
	const char *itemText; // (ͼƬ·ΪNULLʱЧЧ)
	const char *textFaceName; // 
	int textPointSize; // ִС
	BOOL textTransparent; // Ƿ͸
	COLORREF textColor; // ɫ
	COLORREF textBgcolor; // 屳ɫ(ֲ͸ʱЧЧ)
}MP4LaunchImage, *PMP4LaunchImage;

typedef struct {
	const char *mp4_filename; // ҪüMP4ļ
	long long time_begin; // ʼʱ䣬λ(ms)
	long long time_end; // ʱ䣬λ(ms)
	PMP4LaunchImage launch_img; // ƬͷӵͼƬ
	int launch_img_num; // ƬͷӵͼƬС
	int launch_img_time; // Ƭͷʾʱ䣬λ(ms)
}MP4FileSlice, *PMP4FileSlice;

#endif // __LIBDXCAP_DATASTRU__20110805__